unit test_db_form;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, FileUtil, rxdbgrid, ZConnection,
  ZDataset, KDBGrids, KGrids, LSControls, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, ComCtrls, DBGrids, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    DBGrid1: TRxDBGrid;
    Memo1: TMemo;
    RxDBGrid1: TRxDBGrid;
    mtecDataset: TZQuery;
    mtecSource: TDatasource;
    PageControl1: TPageControl;
    OpenOrders: TTabSheet;
    mtecDB_Connect: TZConnection;
    RxTest: TTabSheet;
    procedure DBGrid1UserCheckboxState(Sender: TObject; Column: TColumn;
    var AState: TCheckboxState);
    procedure OpenOrdersShow(Sender: TObject);
    procedure connectDB();
    procedure PageControl1Change(Sender: TObject);
    procedure PageControl1Changing(Sender: TObject; var AllowChange: Boolean);
    procedure RxTestShow(Sender: TObject);
    procedure selectData (query : string);
    procedure DBGrid1CellClick(Column: TColumn);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    RecList: TBookmarklist;
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.OpenOrdersShow(Sender: TObject);
var
  sheet : TTabSheet;
begin
//  mtecDataset.OnFilterRecord:=false;
  sheet := PageControl1.ActivePage;
  Memo1.Append('');
  Memo1.Append('OpenOrdes_vor');
  Memo1.Append(sheet.Name);
  Memo1.Append(intToStr(OpenOrders.PageIndex));
//  OpenOrders.PageIndex:=0;
  OpenOrders.Update;
  PageControl1.Update;
  sheet := PageControl1.ActivePage;
  Memo1.Append('OpenOrdes_nach');
  Memo1.Append(intToStr(OpenOrders.PageIndex));
  Memo1.Append(sheet.Name);
  if OpenOrders.Visible then Memo1.Append('sheet sichtbar');
  if  not mtecDB_Connect.Connected then connectDB;
  selectData('Select * from TM_History');
end;

procedure TForm1.RxTestShow(Sender: TObject);
var
  sheet : TTabSheet;
begin
//  RxDBGrid1.Destroy;
  sheet := PageControl1.ActivePage;
  Memo1.Append('');
  Memo1.Append('RxTest_vor');
  Memo1.Append(sheet.Name);
  Memo1.Append(intToStr(RxTest.PageIndex));
//  RxTest.PageIndex:=0;
  RxTest.Update;
  PageControl1.Update;
  sheet := PageControl1.ActivePage;
  Memo1.Append('RxTest_nach');
  Memo1.Append(intToStr(RxTest.PageIndex));
  Memo1.Append(sheet.Name);
  if RxTest.Visible then Memo1.Append('sheet sichtbar');
  if  not mtecDB_Connect.Connected then connectDB;
  selectData('Select * from TM_OpenOrders');
end;

procedure TForm1.selectData (query : string);
begin
  mtecDataset.Close;
  mtecDataset.SQL.Clear;
  mtecDataset.SQL.Add(query);
  mtecDataset.Active := True;
  mtecDataset.Refresh;
  mtecDataset.Open;
end;

procedure TForm1.DBGrid1CellClick(Column: TColumn);
begin
  if Column.Index=2 then
     RecList.CurrentRowSelected := not RecList.CurrentRowSelected;
end;

procedure TForm1.DBGrid1UserCheckboxState(sender: TObject; column: TColumn;
  var AState: TCheckboxState);
begin
  if RecList.CurrentRowSelected then
    AState := cbChecked
  else
    AState := cbUnchecked;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  RecList := TBookmarkList.Create(RxDBGrid1);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  RecList.Free;
end;

procedure TForm1.connectDB ();
begin
  mtecDataset.Close;
  with mtecDB_Connect do
  begin
    User := mtecDB_Connect.User;
    Password := mtecDB_Connect.Password;
    Protocol := mtecDB_Connect.Protocol;
    HostName := mtecDB_Connect.HostName;
    if mtecDB_Connect.Port <> 0 then
      Port := mtecDB_Connect.Port;
    connect;
  end;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  PageControl1.Update;
end;

procedure TForm1.PageControl1Changing(Sender: TObject; var AllowChange: Boolean);
begin
  PageControl1.Update;
end;

end.

